Require Import Lair_TypeSubst.
(* Require Import Lair_Subst. *)
Require Import Lair_SubstAbstr.


(* ******************************************************************************** *)
(* Subject reduction *)
(* ******************************************************************************** *)

Module LAIR_Lair (Import X : LAIR_PARAMS).
(*  Module Import SubstFacts := LAIR_Subst X.*)
  Module Import SubstFacts := LAIR_SubstAbstr X.

Lemma inversion_lambda_typing_0 : forall G tx e fx t1 t2,
  wf_env G {} -> 
  typing G {} (exp_lam tx e) (typ_fun t1 t2, fx) ->
  exists k, kinding G t1 k /\ exists L,  forall y, y `notin` L -> typing ([(y, binding_typ t1)]++G) (aqual y k {}) (open_exp 0 y e) ((open_typ 0 y t2), fx).
Proof.
intros G tx e fx t1 t2 wf_G T.
remember (typ_fun t1 t2, fx) as tfx.
remember (exp_lam tx e) as ee.
remember ({}) as A.
revert t1 t2 fx Heqtfx Heqee HeqA.
induction T; try solve [intros; discriminate].
Case "type_ABS".
intros.
  exists k.
  assert ((t_x = t1) /\ (t_e = t2)) as teq.
  destruct (ptype_cases (typ_fun t_x t_e) A fx) as [LL | RR].
     rewrite LL in Heqtfx. injection Heqtfx. intros. subst. auto.
     rewrite RR in Heqtfx. discriminate.
  destruct teq. subst.
  injection Heqtfx; intros; subst.
  injection Heqee; intros; subst.
  split.
   assumption.
   exists L.   
   assumption.
Case "type_AFN".  
intros.
 subst.
 injection Heqtfx; intros; subst.
 assert (A1 = {} /\ A2 = {}) as Anil. 
   eauto using split_nil_nil.
 destruct Anil; subst.
 pose proof (IHT wf_G _ _ _ (refl_equal (typ_fun t1 t2, fx1)) (refl_equal (exp_lam tx e)) (refl_equal {})) as fromIH.
 destruct fromIH as [k [Kinding [L fa_T]]].
 exists k; split.
   assumption.
   exists (L `union` dom G).
   intros.
     eapply type_AFN.
       eapply split_nil_A_2; eauto.
       eapply fa_T. fsetdec. 
       apply H0.
       eapply effect_ok_weakening; eauto using wf_env_typ.              
         eapply wf_env_typ. apply wf_G. fsetdec. eapply kinding_wf_typ; eauto.
Case "type_CONV".            
intros.
  subst.
  injection Heqtfx; intros; subst.
  pose proof (tequiv_preserves_fun_shape _ _ _ H) as shape.
  destruct shape as [t1' [t2' teq]].
  subst.
  pose proof (tequiv_fun_injection _ _ _ _ H) as teqf.
  destruct teqf as [cut_t1 cut_t2].
  pose proof (IHT wf_G _ _ _ (refl_equal (typ_fun t1' t2', fx0)) (refl_equal (exp_lam tx e)) (refl_equal {})) as fromIH.
  destruct fromIH as [k [Kinding [L fa_T]]].
  exists k.
    split.
     eapply tequiv_preserves_kinding; eauto using te_SYM.

     exists (L `union` dom G).
     intros.
      assert (y `notin` L) as ynot. fsetdec.
      pose proof (fa_T y ynot) as T_body.
      rewrite_env (nil ++ [(y, binding_typ t1')] ++ G) in T_body.
      assert (wf_env (nil ++ [(y, binding_typ t1')] ++ G) (aqual y k {})) as wf_yG. 
       simpl_env. 
       destruct (aqual_cases {} y k) as [LL | RR].
         rewrite LL.
          eapply wf_env_typ. apply wf_G. fsetdec. eapply kinding_wf_typ; eauto. 
         rewrite RR.
          eapply wf_env_typ_A. assumption. fsetdec. eapply kinding_wf_typ; eauto.
      pose proof (tequiv_soundness _ _ _ _ _ _ _ _ _ wf_yG T_body cut_t1) as T_body'.
      simpl_env in T_body'.
      eapply type_CONV; eauto using tequiv_open_equiv.
Qed.


Lemma inversion_lambda_typing_1 : forall G tx e fx t1 t2,
  wf_env G {} -> 
  typing G {} (exp_lam tx e) (typ_qtype (typ_fun t1 t2), fx) ->
  exists k, kinding G t1 k /\ exists L,  forall y, y `notin` L -> typing ([(y, binding_typ t1)]++G) (aqual y k {}) (open_exp 0 y e) ((open_typ 0 y t2), fx).
Proof.
intros G tx e fx t1 t2 wf_G T.
remember (typ_qtype (typ_fun t1 t2), fx) as tfx.
remember (exp_lam tx e) as ee.
remember ({}) as A.
revert t1 t2 fx Heqtfx Heqee HeqA.
induction T; try solve [intros; discriminate].
Case "type_ABS".
intros.
  exists k.
  assert ((t_x = t1) /\ (t_e = t2)) as teq.
  destruct (ptype_cases (typ_fun t_x t_e) A fx) as [LL | RR].
     rewrite LL in Heqtfx. discriminate. 
     rewrite RR in Heqtfx. injection Heqtfx. intros. subst. auto.
  destruct teq. subst.
  injection Heqtfx; intros; subst.
  injection Heqee; intros; subst.
  split.
   assumption.
   exists L.   
   assumption.
Case "type_AFN".  
intros.
 subst.
 injection Heqtfx; intros; subst.
 assert (A1 = {} /\ A2 = {}) as Anil. 
   eauto using split_nil_nil.
 destruct Anil; subst.
 pose proof (IHT wf_G _ _ _ (refl_equal (typ_qtype (typ_fun t1 t2), fx1)) (refl_equal (exp_lam tx e)) (refl_equal {})) as fromIH.
 destruct fromIH as [k [Kinding [L fa_T]]].
 exists k; split.
   assumption.
   exists (L `union` dom G).
   intros.
     eapply type_AFN.
       eapply split_nil_A_2; eauto.
       eapply fa_T. fsetdec. 
       apply H0.
       eapply effect_ok_weakening; eauto using wf_env_typ.              
         eapply wf_env_typ. apply wf_G. fsetdec. eapply kinding_wf_typ; eauto.
Case "type_CONV".            
intros.
  subst.
  injection Heqtfx; intros; subst.
  pose proof (tequiv_preserves_qtyp_shape _ _ _ H) as shape.
  destruct shape as [t1' [t2' teq]].
  subst.
  pose proof (tequiv_qtype_injection _ _  H) as teqQ.
  pose proof (tequiv_fun_injection _ _ _ _ teqQ) as teqf.
  destruct teqf as [cut_t1 cut_t2].
  pose proof (IHT wf_G _ _ _ (refl_equal (typ_qtype (typ_fun t1' t2'), fx0)) (refl_equal (exp_lam tx e)) (refl_equal {})) as fromIH.
  destruct fromIH as [k [Kinding [L fa_T]]].
  exists k.
    split.
     eapply tequiv_preserves_kinding; eauto using te_SYM.

     exists (L `union` dom G).
     intros.
      assert (y `notin` L) as ynot. fsetdec.
      pose proof (fa_T y ynot) as T_body.
      rewrite_env (nil ++ [(y, binding_typ t1')] ++ G) in T_body.
      assert (wf_env (nil ++ [(y, binding_typ t1')] ++ G) (aqual y k {})) as wf_yG. 
       simpl_env. 
       destruct (aqual_cases {} y k) as [LL | RR].
         rewrite LL.
          eapply wf_env_typ. apply wf_G. fsetdec. eapply kinding_wf_typ; eauto. 
         rewrite RR.
          eapply wf_env_typ_A. assumption. fsetdec. eapply kinding_wf_typ; eauto.
      pose proof (tequiv_soundness _ _ _ _ _ _ _ _ _ wf_yG T_body cut_t1) as T_body'.
      simpl_env in T_body'.
      eapply type_CONV; eauto using tequiv_open_equiv.
Qed.

Lemma inversion_lambda_typing : forall G tx e tt fx t1 t2,
  wf_env G {} ->
  typing G {} (exp_lam tx e) (tt, fx) ->
  (tt = typ_fun t1 t2 \/ tt = typ_qtype (typ_fun t1 t2)) -> 
  exists k, kinding G t1 k /\ exists L,  forall y, y `notin` L -> typing ([(y, binding_typ t1)]++G) (aqual y k {}) (open_exp 0 y e) ((open_typ 0 y t2), fx).
Proof.
intros.
destruct H1 as [ftype | qtype]; (subst; (eauto using inversion_lambda_typing_0, inversion_lambda_typing_1)).
Qed.

Lemma inversion_tab_typing_0 : forall G k k' e fx t,
  wf_env G {} ->
  typing G {} (exp_tab k e) (typ_univ k' NO_FX t, fx) ->
  (k = k' /\
    exists L,  forall a, a `notin` L -> typing ([(a, binding_kind k)]++G) {} (open_exp_typ 0 a e) ((open_typ_typ 0 a t), fx)).
Proof.
intros G k k' e fx t wf_G T.
remember (typ_univ k' NO_FX t, fx) as tfx.
remember (exp_tab k e) as ee.
remember ({}) as A.
revert t fx Heqtfx Heqee HeqA.
induction T; try solve [intros; discriminate].
Case "type_TAB".
intros.
injection Heqee; intros; subst.
assert ((k=k') /\ (t=t_e)) as EQ.
  destruct (ptype_cases (typ_univ k NO_FX t_e) {} fx) as [LL | RR].
      rewrite LL in Heqtfx; injection Heqtfx; intros; subst; auto.
      rewrite RR in Heqtfx. discriminate.
destruct EQ; subst k'; subst t_e.
injection Heqtfx; intros; subst fx0.
split.
  reflexivity.
  
  exists (L `union` fx).
    intros.
    eapply H; (eauto || fsetdec).

Case "type_TAB_FX".
intros.
  destruct (ptype_cases (typ_univ k0 FX t_e) A fx) as [C | C];
      (rewrite C in Heqtfx; discriminate).

Case "type_AFN".
intros. 
 injection Heqtfx; intros; subst.
assert ((A1 = {}) /\ (A2 = {})) as A1nil.
  eauto using split_nil_nil.
destruct A1nil. subst A1.
pose proof (IHT wf_G _ _ (refl_equal (typ_univ k' NO_FX t0, fx1)) 
                         (refl_equal (exp_tab k e)) (refl_equal {})) as IH.
destruct IH as [keq [L coF]].
subst.
split.
  reflexivity.
  
  exists (L `union` dom G). intros.
  assert (wf_env ([(a, binding_kind k')]++G) {}) as wf_G'.
    eapply  wf_env_kind; (eauto || fsetdec).
  eapply type_AFN; eauto using effect_ok_weakening.

Case "type_CONV".
intros. 
injection Heqtfx; intros; subst.

pose proof (tequiv_preserves_univ_shape _ _ _ _ H) as Shape.
destruct Shape as [t0' [t_eq teqv]].
subst.
pose proof (IHT wf_G _ _ (refl_equal (typ_univ k' NO_FX t0', fx0)) (refl_equal (exp_tab k e)) (refl_equal {})) as IH.
destruct IH as [keq [L coF]].
subst.
split.
  reflexivity.
 
  exists (L `union` dom G).
  intros.
  eapply type_CONV; eauto using tequiv_open_typ_equiv, te_SYM.
Qed.


Lemma inversion_tab_typing_1 : forall G k k' e fx t,
  wf_env G {} ->
  typing G {} (exp_tab k e) (typ_qtype (typ_univ k' NO_FX t), fx) ->
  (k = k' /\
    exists L,  forall a, a `notin` L -> typing ([(a, binding_kind k)]++G) {} (open_exp_typ 0 a e) ((open_typ_typ 0 a t), fx)).
Proof.
intros G k k' e fx t wf_G T.
remember (typ_qtype(typ_univ k' NO_FX t), fx) as tfx.
remember (exp_tab k e) as ee.
remember ({}) as A.
revert t fx Heqtfx Heqee HeqA.
induction T; try solve [intros; discriminate].
Case "type_TAB".
intros.
injection Heqee; intros; subst.
assert ((k=k') /\ (t=t_e)) as EQ.
  destruct (ptype_cases (typ_univ k NO_FX t_e) {} fx) as [LL | RR].
      rewrite LL in Heqtfx. discriminate.
      rewrite RR in Heqtfx; injection Heqtfx; intros; subst; auto.

destruct EQ; subst k'; subst t_e.
injection Heqtfx; intros; subst fx0.
split.
  reflexivity.
  
  exists (L `union` fx).
    intros.
    eapply H; (eauto || fsetdec).

Case "type_TAB_FX".
intros.
  destruct (ptype_cases (typ_univ k0 FX t_e) A fx) as [C | C];
      (rewrite C in Heqtfx; discriminate).

Case "type_AFN".
intros. 
 injection Heqtfx; intros; subst.
assert ((A1 = {}) /\ (A2 = {})) as A1nil.
  eauto using split_nil_nil.
destruct A1nil. subst A1.
pose proof (IHT wf_G _ _ (refl_equal (typ_qtype (typ_univ k' NO_FX t0), fx1)) 
                         (refl_equal (exp_tab k e)) (refl_equal {})) as IH.
destruct IH as [keq [L coF]].
subst.
split.
  reflexivity.
  
  exists (L `union` dom G). intros.
  assert (wf_env ([(a, binding_kind k')]++G) {}) as wf_G'.
    eapply  wf_env_kind; (eauto || fsetdec).
  eapply type_AFN; eauto using effect_ok_weakening.

Case "type_CONV".
intros. 
injection Heqtfx; intros; subst.

pose proof (tequiv_preserves_qtyp_univ_shape _ _ _ _ H) as Shape.
destruct Shape as [t0' [t_eq teqv]].
subst.
pose proof (IHT wf_G _ _ (refl_equal (typ_qtype(typ_univ k' NO_FX t0'), fx0)) (refl_equal (exp_tab k e)) (refl_equal {})) as IH.
destruct IH as [keq [L coF]].
subst.
split.
  reflexivity.
 
  exists (L `union` dom G).
  intros.
  eapply type_CONV; eauto using tequiv_open_typ_equiv, te_SYM.
Qed.

Lemma inversion_tab_typing : forall G k k' e fx t tt,
  wf_env G {} ->
  typing G {} (exp_tab k e) (tt, fx) ->
  (tt = typ_univ k' NO_FX t \/ tt = typ_qtype (typ_univ k' NO_FX t)) -> 
  (k = k' /\
    exists L,  forall a, a `notin` L -> typing ([(a, binding_kind k)]++G) {} (open_exp_typ 0 a e) ((open_typ_typ 0 a t), fx)).
Proof.
intros.
destruct H1; (subst; eauto using inversion_tab_typing_0, inversion_tab_typing_1).
Qed.

Lemma inversion_tab_typing_FX_0 : forall G k e fx t,
  wf_env G {} ->
  typing G {} (exp_tab k e) (typ_univ kind_N FX t, fx) ->
  (k = kind_N /\
    exists L, forall a, a `notin` L -> typing ([(a, binding_kind k)]++G) {} (open_exp_typ 0 a e) ((open_typ_typ 0 a t), fx `union` singleton a)).
Proof.
intros G k e fx t wf_G T.
remember (typ_univ kind_N FX t, fx) as tfx.
remember (exp_tab k e) as ee.
remember ({}) as A.
revert t fx Heqtfx Heqee HeqA.
induction T; try solve [intros; discriminate].

Case "type_TAB".
intros.
 destruct (ptype_cases (typ_univ k0 NO_FX t_e) A fx) as [C | C];
    (rewrite C in Heqtfx; discriminate).

Case "type_TAB_FX".
intros.
injection Heqee; intros; subst.
assert ((k=kind_N) /\ (t=t_e)) as EQ.
  destruct (ptype_cases (typ_univ k FX t_e) {} fx) as [LL | RR].
      rewrite LL in Heqtfx; injection Heqtfx; intros; subst; auto.
      rewrite RR in Heqtfx. discriminate.
destruct EQ; subst k. subst t_e.
injection Heqtfx; intros; subst fx0.
split.
  reflexivity.
  
  exists (L `union` fx).
    intros.
    eapply H0; (eauto || fsetdec).

Case "type_AFN".
intros. 
 injection Heqtfx; intros; subst.
assert ((A1 = {}) /\ (A2 = {})) as A1nil.
  eauto using split_nil_nil.
destruct A1nil. subst A1.
pose proof (IHT wf_G _ _ (refl_equal (typ_univ kind_N FX t0, fx1)) 
                         (refl_equal (exp_tab k e)) (refl_equal {})) as IH.
destruct IH as [keq [L coF]].
subst.
split.
  reflexivity.
  
  exists (L `union` dom G `union` fx0). intros.
  assert (wf_env ([(a, binding_kind kind_N)]++G) {}) as wf_G'.
    eapply  wf_env_kind; (eauto || fsetdec).
  eapply type_AFN.
    apply H.
    eapply coF; eauto.
    eapply split_commutes.
      eapply split_extension_R; (eauto using split_commutes || fsetdec).
    unfold effect_ok in H1.
    unfold effect_ok.
    intros.
      destruct (AtomSet.F.union_1 H3) as [in_fx0 | ina].
        eapply binds_concat_ok; eauto using wf_is_ok.
        assert (a0 = a). fsetdec. subst.
        eapply binds_head; eauto using binds_singleton.

Case "type_CONV".
intros. 
injection Heqtfx; intros; subst.

pose proof (tequiv_preserves_univ_shape _ _ _ _ H) as Shape.
destruct Shape as [t0' [t_eq teqv]].
subst.
pose proof (IHT wf_G _ _ (refl_equal (typ_univ kind_N FX t0', fx0)) (refl_equal (exp_tab k e)) (refl_equal {})) as IH.
destruct IH as [keq [L coF]].
subst.
split.
  reflexivity.
 
  exists (L `union` dom G).
  intros.
  eapply type_CONV; eauto using tequiv_open_typ_equiv, te_SYM.
Qed.

Lemma inversion_tab_typing_FX_1 : forall G k e fx t,
  wf_env G {} ->
  typing G {} (exp_tab k e) (typ_qtype(typ_univ kind_N FX t), fx) ->
  (k = kind_N /\
    exists L, forall a, a `notin` L -> typing ([(a, binding_kind k)]++G) {} (open_exp_typ 0 a e) ((open_typ_typ 0 a t), fx `union` singleton a)).
Proof.
intros G k e fx t wf_G T.
remember (typ_qtype(typ_univ kind_N FX t), fx) as tfx.
remember (exp_tab k e) as ee.
remember ({}) as A.
revert t fx Heqtfx Heqee HeqA.
induction T; try solve [intros; discriminate].

Case "type_TAB".
intros.
 destruct (ptype_cases (typ_univ k0 NO_FX t_e) A fx) as [C | C];
    (rewrite C in Heqtfx; discriminate).

Case "type_TAB_FX".
intros.
injection Heqee; intros; subst.
assert ((k=kind_N) /\ (t=t_e)) as EQ.
  destruct (ptype_cases (typ_univ k FX t_e) {} fx) as [LL | RR].
      rewrite LL in Heqtfx. discriminate.
      rewrite RR in Heqtfx; injection Heqtfx; intros; subst; auto.
destruct EQ; subst k. subst t_e.
injection Heqtfx; intros; subst fx0.
split.
  reflexivity.
  
  exists (L `union` fx).
    intros.
    eapply H0; (eauto || fsetdec).

Case "type_AFN".
intros. 
 injection Heqtfx; intros; subst.
assert ((A1 = {}) /\ (A2 = {})) as A1nil.
  eauto using split_nil_nil.
destruct A1nil. subst A1.
pose proof (IHT wf_G _ _ (refl_equal (typ_qtype (typ_univ kind_N FX t0), fx1)) 
                         (refl_equal (exp_tab k e)) (refl_equal {})) as IH.
destruct IH as [keq [L coF]].
subst.
split.
  reflexivity.
  
  exists (L `union` dom G `union` fx0). intros.
  assert (wf_env ([(a, binding_kind kind_N)]++G) {}) as wf_G'.
    eapply  wf_env_kind; (eauto || fsetdec).
  eapply type_AFN.
    apply H.
    eapply coF; eauto.
    eapply split_commutes.
      eapply split_extension_R; (eauto using split_commutes || fsetdec).
    unfold effect_ok in H1.
    unfold effect_ok.
    intros.
      destruct (AtomSet.F.union_1 H3) as [in_fx0 | ina].
        eapply binds_concat_ok; eauto using wf_is_ok.
        assert (a0 = a). fsetdec. subst.
        eapply binds_head; eauto using binds_singleton.

Case "type_CONV".
intros. 
injection Heqtfx; intros; subst.

pose proof (tequiv_preserves_qtyp_univ_shape _ _ _ _ H) as Shape.
destruct Shape as [t0' [t_eq teqv]].
subst.
pose proof (IHT wf_G _ _ (refl_equal (typ_qtype(typ_univ kind_N FX t0'), fx0)) (refl_equal (exp_tab k e)) (refl_equal {})) as IH.
destruct IH as [keq [L coF]].
subst.
split.
  reflexivity.
 
  exists (L `union` dom G).
  intros.
  eapply type_CONV; eauto using tequiv_open_typ_equiv, te_SYM.
Qed.

  Module Import EnvironmentFacts := LAIR_Environment X.
  Module Import TypeSubstFacts := LAIR_TypeSubst X.

Lemma inversion_tab_typing_FX : forall G k e fx t tt,
  wf_env G {} ->
  typing G {} (exp_tab k e) (tt, fx) ->
  (tt = typ_univ kind_N FX t \/ tt = typ_qtype (typ_univ kind_N FX t)) -> 
  (k = kind_N /\
    exists L, forall a, a `notin` L -> typing ([(a, binding_kind k)]++G) {} (open_exp_typ 0 a e) ((open_typ_typ 0 a t), fx `union` singleton a)).
Proof.
intros.
destruct H1; (subst; eauto using inversion_tab_typing_FX_0, inversion_tab_typing_FX_1).
Qed.
 
Theorem preservation : forall G e t fx e', 
  wf_env G {} -> only_names G {} -> 
  MS_consistent Model Signature -> wf_signature Signature ->
  typing G {} e (t,fx) -> eval e e' ->  typing G {} e' (t, fx).
Proof.
intros G e t fx e' wf_G on_G MS wfSig T E.
assert (typing G {} e (t, fx)) as Te. auto.
remember (t,fx) as tfx.
remember {} as A.
generalize dependent e'.
generalize dependent t.
generalize dependent fx.
induction T; try solve [intros _ _ _ e' E; inversion E].
Case "type_NEW".
intros fx0 t0 tfx e' E.
inversion E.
 SCase "eval_new1".
  subst.
  pose proof (IHT wf_G on_G T (refl_equal {}) _ _ (refl_equal (t, fx)) _ H3).
  eapply type_NEW; eauto.
 SCase "eval_new1_bot". subst.
  eapply type_BOT.
Case "type_APP".
  intros.
  inversion E.
  SCase "eval_app1".
    clear IHT2.
    subst.
    assert (A1 = {} /\ A2 = {}) as A12_nil.
      eauto using split_nil_nil.
    destruct A12_nil as [A1_nil A2_nil].
    subst A1.
    pose proof (IHT1 wf_G on_G T1 (refl_equal {})  _ _ (refl_equal (t_e1, fx1)) _ H5) as T_e1'.
    eapply type_APP; eauto.
  SCase "eval_app1_bot".
    subst. eapply type_BOT.
  SCase "eval_app2".
    clear IHT1. subst. 
    assert (A1 = {} /\ A2 = {}) as A12_nil.
      eauto using split_nil_nil.
    destruct A12_nil as [A1_nil A2_nil].
    subst A2.
    pose proof (IHT2 wf_G on_G T2 (refl_equal {}) _ _ (refl_equal (t2, fx2)) _ H5) as T_e2'.
    eapply type_CONV.
      eapply type_APP; eauto using T_e2'.
      eapply te_SYM.
        eapply tequiv_open_red; eauto.
  SCase "eval_app2_bot".
    subst. eapply type_BOT.
  SCase "eval_beta".
    subst. clear IHT1 IHT2.
    assert (A1 = {} /\ A2 = {}) as A12_nil.
       eauto using split_nil_nil.
    destruct A12_nil; subst.
    pose proof (inversion_lambda_typing _ _ _ _ _ _ _ wf_G T1 H0) as T_e.
    destruct T_e as [ k [kind_t1 [L fa_T]]].

    pick fresh y.
    assert (y `notin` L) as y_notin_L.
       fsetdec.
    pose proof (fa_T _ y_notin_L) as T_body.
    assert (rc_typ t G) as rc_t.
      assert (rc_typ (typ_fun t2 t) G) as rc_ft.
        destruct H0.
         rewrite H0 in T1.
          pose proof (typing_wf_typ _ _ _ _ _ T1) as wf_ft.
          inversion wf_ft as [wf_ft1 wf_wft2]. assumption.
         rewrite H0 in T1. 
          pose proof (typing_wf_typ _ _ _ _ _ T1) as wf_qt.
          inversion wf_qt as [lc_qt rc_qt]. inversion rc_qt. assumption.
      inversion rc_ft. eauto.
     cutrewrite (open_exp 0 e2 e = subst_exp y e2 (open_exp 0 y e)). 
     cutrewrite (open_typ 0 e2 t = subst_typ y e2 (open_typ 0 y t)).
     rewrite_env (subst_gamma y e2 nil ++ G).
     eapply subst_preserves_typing. 
        assumption.  
        assumption.
        apply kind_t1.
        fsetdec.
        simpl_env.  
           eapply wf_env_extension. 
              assumption. 
              fsetdec.
              assumption.
        rewrite_env ([(y, binding_typ t2)] ++ G). apply T_body.
        assumption.
        apply T2.
        apply (split_commutes _ _ _ H1).
        (* cut 1: open_typ 0 e2 t = subst_typ y e2 (open_typ 0 y t) *) 
        eapply subst_typ_intro.
          apply rc_t.
          fsetdec.
        (* cut 2: open_exp 0 e2 e = subst_exp y e2 (open_exp 0 y e) *) 
        eapply subst_exp_intro.
          assert (rc_exp (exp_lam t1 e) G) as rc_le.
            pose proof (typing_wf_exp _ _ _ _ _ T1) as wf_le.
            inversion wf_le as [lc_le rc_le]. assumption.
          inversion rc_le. eauto.
        fsetdec.
  SCase "eval_b1".
    subst.
    eapply in_eqns_consistency.
      apply MS.
      apply H6.
      apply H8.
      rewrite_env (nil ++ G).
      eapply type_B1; eauto using typing_wf_exp.
  SCase "eval_b2".
    subst.
     rewrite_env (nil ++ G).
     eapply type_B1; eauto using typing_wf_exp.
Case "typing_TAP_NOFX".
  intros.
  inversion E.
  SCase "eval_tap1".
    subst.
    eapply type_TAP_NOFX; eauto using IHT.

  SCase "eval_tap1_bot".
    subst.
    eapply type_BOT; eauto.

  SCase "eval_tap".
    subst.
    pose proof (inversion_tab_typing _ _ _ _ _ _ _ wf_G T H) as Inv.
    destruct Inv as [k0_eq [L coF]]. subst.
    
    pick fresh b.
    
    assert (b `notin` dom G) as b_notin_G. fsetdec.
    assert (rc_exp e1 G) as rc_e1.
      pose proof (typing_wf_exp _ _ _ _ _ T) as wf_Lam_e1.
      inversion wf_Lam_e1 as [lc_Lam_e1 rc_Lam_e1].
      inversion rc_Lam_e1; eauto.
    assert (rc_typ t' G) as rc_t'.
      assert (rc_typ (typ_univ k NO_FX t') G) as rc_kt'.
        destruct H.
          subst. pose proof (typing_wf_typ _ _ _ _ _ T) as wf_kt'.
            inversion wf_kt'. assumption.
          subst. pose proof (typing_wf_typ _ _ _ _ _ T) as wf_qkt'.
            inversion wf_qkt'. inversion H1. assumption.
       inversion rc_kt'. assumption. 
    rewrite (subst_typ_exp_intro G t e1 b 0 rc_e1 b_notin_G).
    rewrite (subst_typ_typ_intro G t t' b 0 rc_t' b_notin_G).
    
    rewrite_env ((subst_typ_gamma b t nil)++G).
    eapply type_substitution_preserves_typing.
      assumption.
      assumption.
      simpl_env; eapply wf_env_kind; eauto.
      simpl_env; (eapply (coF b); fsetdec).
      fsetdec.
      assumption.

  SCase "eval_b3".
    subst.
    eapply in_eqns_consistency.
      apply MS.
      apply H4.
      apply H6.
      rewrite_env (nil ++ G).
      eapply type_B2; eauto using kinding_wf_typ.
    
  SCase "eval_b4".
    subst.
    rewrite_env (nil ++ G).
    eapply type_B2; eauto using kinding_wf_typ.

Case "typing_TAP_FX".
    intros.
    inversion E.
    
    SCase "eval_tap1".
      subst.
      eapply type_TAP_FX; eauto using IHT.
      
    SCase "eval_tap1_bot".
      subst.
      eapply type_BOT; eauto.

    SCase "eval_tap".
      subst.
      pose proof (inversion_tab_typing_FX _ _ _ _ _ _ wf_G T H) as Inv.
      destruct Inv as [k0_eq [L coF]]. subst.
    
      pick fresh b.
    
      assert (b `notin` dom G) as b_notin_G. fsetdec.
 
      assert (rc_exp e1 G) as rc_e1.
        pose proof (typing_wf_exp _ _ _ _ _ T) as wf_Lam_e1.
        inversion wf_Lam_e1 as [lc_Lam_e1 rc_Lam_e1].
        inversion rc_Lam_e1; eauto.
      assert (rc_typ t' G) as rc_t'.
        assert (rc_typ (typ_univ kind_N FX t') G) as rc_kt'.
          destruct H.
            subst. pose proof (typing_wf_typ _ _ _ _ _ T) as wf_kt'.
              inversion wf_kt'. assumption.
            subst. pose proof (typing_wf_typ _ _ _ _ _ T) as wf_qkt'.
              inversion wf_qkt'. inversion H2. assumption.
         inversion rc_kt'. assumption. 
    rewrite (subst_typ_exp_intro G a e1 b 0 rc_e1 b_notin_G).
    rewrite (subst_typ_typ_intro G a t' b 0 rc_t' b_notin_G).
    
    rewrite_env ((subst_typ_gamma b a nil)++G).
    inversion H1. subst fx'.
    eapply (type_substitution_preserves_typing_fx G nil {} b (open_exp_typ 0 b e1) (open_typ_typ 0 b t') (fx `union` singleton b) fx a).
      assumption.
      assumption.
      simpl_env; eapply wf_env_kind; eauto.
      simpl_env. eapply (coF b). fsetdec.
      cutrewrite (fx `union` singleton b = singleton b `union` fx).
      eapply split_A. assert (b `notin` fx) as b_notin_fx. fsetdec. fsetdec.
      fsetdec.
      assumption.
      unfold not. intros.
        assert (a `in` {}).
         rewrite <- H2.
         eapply AtomSet.F.inter_3. fsetdec. assumption.
        fsetdec.

  SCase "eval_b3".
    subst.
    eapply in_eqns_consistency.
      apply MS.
      apply H5.
      apply H7.
      rewrite_env (nil ++ G).
      eapply type_B2; eauto using kinding_wf_typ.
    
  SCase "eval_b4".
    subst.
    rewrite_env (nil ++ G).
    eapply type_B2; eauto using kinding_wf_typ.

Case "typing_BOT".
intros. inversion E. subst. assumption.

Case "typing_DROP".
intros.
eapply type_DROP; (eapply IHT; eauto). 

Case "type_AFN".
intros. subst.
pose proof (split_nil_nil _ _ H) as Split. destruct Split as [A1nil A2nil].
eapply type_AFN; eauto using IHT, wf_split1, only_names_split1. 

Case "type_B".
intros;
inversion E. subst.
eapply type_B3; eauto.

Case "type_CONV".
intros.
eapply type_CONV; eauto using IHT.
Qed.

End LAIR_Lair.
