(* This is a stub version of Lair_Subst.v  ... for faster compilation *)

Require Export Lair_Tequiv.

Module LAIR_SubstAbstr (Import X : LAIR_PARAMS).
  Module Export ModelFacts := LAIR_Model X.
  Module Export TequivFacts := LAIR_Tequiv X.
  Module Export UtilFacts := LAIR_Util X.

(* Separate lemma instead of complicating the main subst lemma with disjuncts *)
Lemma nofree_subst_preserves_typing : forall G1 G2 A x tx e t v fx_e fx_v fx_ev ka,
  wf_signature Signature ->
  wf_env G1 {} -> kinding G1 tx ka -> (x `notin` A) -> 
  wf_env (G2 ++ [(x, binding_typ tx)] ++ G1) A ->
  typing (G2 ++ [(x, binding_typ tx)] ++ G1) A e (t, fx_e) ->
  value v -> typing G1 {} v (tx, fx_v) -> splitA fx_v fx_e fx_ev ->
  typing ((subst_gamma x v G2) ++ G1) A (subst_exp x v e) ((subst_typ x v t), fx_e).
Admitted.

(* Main substitution lemma *)
Lemma subst_preserves_typing : forall G1 G2 A x tx k e t v fx_e fx_v fx_ev, 
  wf_signature Signature -> 
  wf_env G1 {} -> kinding G1 tx k -> (x `notin` A) -> (* wf_env (G2 ++ G1) A ->  *)
  wf_env (G2 ++ [(x, binding_typ tx)] ++ G1) (aqual x k A) ->
  typing (G2 ++ [(x, binding_typ tx)] ++ G1) (aqual x k A) e (t, fx_e) ->
  value v -> typing G1 {} v (tx, fx_v) -> splitA fx_v fx_e fx_ev ->
  typing ((subst_gamma x v G2) ++ G1) A (subst_exp x v e) ((subst_typ x v t), fx_ev).
Proof.
Admitted.

End LAIR_SubstAbstr.
