Require Export Lair_Infrastructure.
Set Undo 100000.

Lemma effect_splitting : forall fx_e fx0 fx1 fx2 fx1' a b, 
  splitA fx1 fx2 fx_e -> 
  splitA (singleton a) fx0 fx_e -> 
  splitA (singleton a) fx1' fx1 ->
  a `in` fx1 -> a `notin` fx2 ->  b `notin` fx1 -> b `notin` fx2 -> 
  splitA (singleton b `union` fx1') fx2 (singleton b `union` fx0).
  intros until 1. rename H into s0.
  intros split_fx split_a_fx1' a_in_fx1 a_notin_fx2 b_notin_fx1 b_notin_fx2.
  assert (fx0 = fx1' `union` fx2) as un_1.
     clear - split_a_fx1' a_notin_fx2 a_in_fx1 s0 split_fx.
     inversion split_fx.
     rewrite <- H2 in s0.
     inversion s0.
     inversion split_a_fx1'.
     rewrite <- H10 in H3.
     rewrite (union_associative (singleton a) fx1' fx2) in H3.
     assert (a `notin` (fx1' `union` fx2)) as a_12.
      assert (a `notin` fx1'). 
         clear - H7. unfold not; intro. 
         assert (a `in` {}).
           rewrite <- H7. fsetdec. 
         fsetdec.
      notin_solve.
     assert (a `notin` fx0) as a_0.
       clear - H. unfold not; intro. 
         assert (a `in` {}).
           rewrite <- H. fsetdec. 
         fsetdec.
     symmetry. eapply union_identity; eauto.
     rewrite un_1.
     rewrite <- (union_associative (singleton b) fx1' fx2).
     eapply split_A.
     (* interstection *)
     rewrite (intersection_commutes  (singleton b `union` fx1') fx2).
     rewrite (demorgan_1 fx2 (singleton b) fx1').
     rewrite (intersection_commutes fx2 fx1').
     assert ((fx1' `inter` fx2) = {}) as i_nil.
       clear - s0 split_a_fx1' a_notin_fx2.
       inversion s0.
       inversion split_a_fx1'.
       rewrite <- H6 in H.
       clear - H a_notin_fx2.
       rewrite (intersection_commutes (singleton a `union` fx1') fx2) in H.
       rewrite (demorgan_1 fx2 (singleton a) fx1') in H.
       rewrite (intersection_commutes fx2 fx1') in H. 
       assert (AtomSet.F.Empty {}). apply  AtomSet.F.empty_1.
       rewrite <- H in H0.
       pose proof (AtomSet.F.is_empty_1 H0).
       destruct (empty_union _ _ H1).
       assumption.
     rewrite i_nil.
     assert (fx2 `inter` singleton b = {}) as i_nil'.
       clear - b_notin_fx2.
       fsetdec.
     rewrite i_nil'.
       fsetdec.
Qed.

Module LAIR_TypeSubst (Import X : LAIR_PARAMS).
  Module Export Y := LAIR_Model X.

Lemma type_substitution_preserves_typing : forall G1 G2 A a ka e te fx_e t, 
  wf_signature Signature -> 
  wf_env G1 {} -> 
  wf_env (G2 ++ [(a, binding_kind ka)] ++ G1) A -> 
  typing (G2 ++ [(a, binding_kind ka)] ++ G1) A e (te, fx_e) -> a `notin` fx_e ->
  kinding G1 t ka -> typing ((subst_typ_gamma a t G2) ++ G1) A (subst_typ_exp a t e) ((subst_typ_typ a t te), fx_e).
Admitted.

  Module Export Z := LAIR_Infrastructure X.
Lemma type_substitution_preserves_typing_fx : forall G1 G2 A a e t fx_e fx (b:atom), 
  wf_signature Signature -> 
  wf_env G1 {} -> 
  wf_env (G2 ++ [(a, binding_kind kind_N)] ++ G1) A -> 
  typing (G2 ++ [(a, binding_kind kind_N)] ++ G1) A e (t, fx_e) -> 
  splitA (singleton a) fx fx_e ->  kinding G1 b kind_N -> b `notin` fx ->
  typing ((subst_typ_gamma a b G2) ++ G1) A (subst_typ_exp a b e) ((subst_typ_typ a b t), (singleton b) `union` fx).
intros until 1. rename H into wf_sig.
intros wf_G1 wf_G T split_fx k_b b_notin_fx.
assert (typing (G2 ++ [(a, binding_kind kind_N)] ++ G1) A e (t, fx_e)) as Te; auto.
remember (G2 ++ [(a, binding_kind kind_N)] ++ G1) as G.
remember (t, fx_e) as t_fxe.
generalize dependent Te. 
generalize dependent HeqG.
generalize dependent wf_G.
generalize dependent t.
generalize dependent fx_e.
generalize dependent fx.
generalize dependent G1.
generalize dependent G2.
destruct T using typing_ind2 with
  (P0 := 
    fun (G:gamma) (t:typ) (k:kind) (K:kinding G t k) =>
      forall G1 G2 b, (G = (G2 ++ [(a, binding_kind kind_N)] ++ G1)) -> wf_env G {} -> 
        wf_env G1 {} ->  kinding G1 b kind_N -> 
        kinding ((subst_typ_gamma a b G2) ++ G1) (subst_typ_typ a b t) k)
  (P1 :=
    fun (t:typ) (t':typ) (Te: tequiv t t') =>
      forall a b, tequiv (subst_typ_typ a b t) (subst_typ_typ a b t')).
Case "type_X".
intros.
injection Heqt_fxe; intros; subst.
destruct (split_nil_nil _ _ split_fx). 
assert (a `in` {}); [rewrite <- H; fsetdec | fsetdec].
Case "type_XA".
intros.
injection Heqt_fxe; intros; subst.
destruct (split_nil_nil _ _ split_fx). 
assert (a `in` {}); [rewrite <- H; fsetdec | fsetdec].
Case "type_NEW".
intros. rename fx_e into fx_newe. rename fx into fx_e.
injection Heqt_fxe; intros; subst. 
cut (b <> a). intro b_neq_a.
destruct (binds_concat_inv _ a0 (binding_kind kind_N) _ _ b0) as  [ [a0_notin_G2 binds_a0_tl] | binds_a0_G2 ].
SCase "a0_notin_G2".
  destruct (binds_concat_inv _ a0 (binding_kind kind_N) _ _ binds_a0_tl) as [[a0_notin_a binds_a0_G1] | binds_a0_a].
  SSCase "binds_a0_G1".
    simpl.
     destruct (a==a0) as [a_eq_a0 | a_neq_a0].
       subst; simpl in a0_notin_a; fsetdec.
       assert (b <> a0) as b_neq_a0.
         assert (a0 `in` fx0) as a0_in_fx0.
           inversion split_fx.
           subst fx_newe.
           inversion s. subst.
           assert (a0 `in` (singleton a `union` fx0)).
            rewrite <- H2. fsetdec.
           destruct (AtomSet.F.union_1 H0).
             destruct a_neq_a0. fsetdec.
             assumption.
         unfold not. intros.
         subst b. contradiction.
     cut (exists fx_e', splitA (singleton a) fx_e' fx_e). intro cut_ex.
     destruct cut_ex as [fx_e' split'].
     cut (b `notin` fx_e'). intro b_notin_fxe'.
     eapply type_NEW.
       eapply (IHT G2 G1 wf_G1 k_b fx_e'); eauto using refl_equal.
       eapply IHT0; eauto using refl_equal.
       clear IHT IHT0.
       eapply wf_env_containment; (eauto || fsetdec).
       assert (dom G2 = dom (subst_typ_gamma a b G2)) as domeq. eapply subst_typ_gamma_dom; eauto. 
       rewrite domeq in a0_notin_G2.
       eapply binds_tail; eauto.
       assert (splitA (singleton a0) fx_e' fx0) as splitter. eauto using split_trans_9.
       inversion splitter.
       clear IHT IHT0.
       assert ((AtomSet.F.inter (singleton a0) (singleton b `union` fx_e')) = {}) as inter.
          assert ((AtomSet.F.inter (singleton a0) fx_e') = {}) as inter0.
            inversion s.
            inversion split'. 
            rewrite <- H10 in H3.
            rewrite (demorgan_1 (singleton a0) (singleton a) fx_e') in H3.
            rewrite <- H.
            assert (singleton a0 `inter` singleton a = {}).
              fsetdec.
            reflexivity.
          rewrite (demorgan_1 (singleton a0) (singleton b) fx_e').
          assert (singleton a0 `inter` singleton b = {}).
              fsetdec.
          rewrite H3; rewrite inter0; fsetdec.
        assert ((singleton b `union` singleton a0 `union` fx_e') = 
                (singleton a0 `union` singleton b `union` fx_e')) as ut; [fsetdec | rewrite ut].
        eapply split_A; eauto.
        (* cut b_notin_fxe' *)
        clear IHT IHT0.
        inversion s.
        inversion split'.
        inversion split_fx.
        subst.
        assert (b `notin` (singleton a `union` fx0)) as notin_u.
        notin_solve.
        rewrite H10 in notin_u. fsetdec.
        (* cut : split' *)
        eapply split_trans_10; eauto.
   SSCase "binds_a0_a".
     assert (a0 = a). 
       destruct (binds_singleton_inv _  _ _ _ _ binds_a0_a);
       subst; reflexivity.
     subst.
     simpl.
       destruct (a == a).
       clear IHT.
       assert (a `notin` fx_e) as a_notin_fxe.
        inversion s. unfold not. intros.
        assert (a `in` (singleton a `inter` fx_e)) as ain.
          eapply AtomSet.F.inter_3; (eauto || fsetdec).
        rewrite H in ain. fsetdec.
       eapply type_NEW.
         (* typing e*)
         eapply type_substitution_preserves_typing; eauto.
         (* kinding *)
         eapply IHT0; (eauto || (eapply wf_env_containment; (eauto || fsetdec))).
         (* name b is available in (s G2 ++ G1) *)
          SSSCase "b available".
         inversion k_b.
          destruct (binds_exists_singleton _ _ _ H1) as [G1_1 [G2_1 G1_eq]].
          assert (b `notin` (dom (G2 ++ [(a, binding_kind kind_N)] ++ G1_1))).
           pose proof (wf_is_ok _ _ wf_G) as ok.
           assert (binds b (binding_kind kind_N) ((G2 ++ [(a, binding_kind kind_N)]) ++ G1)).
             eapply binds_weaken_at_head; simpl_env; eauto.
           rewrite G1_eq in H3, ok.
           rewrite_env ((G2 ++ [(a, binding_kind kind_N)] ++ G1_1) ++ [(b, binding_kind kind_N)] ++ G2_1) in H3.
           rewrite_env ((G2 ++ [(a, binding_kind kind_N)] ++ G1_1) ++ [(b, binding_kind kind_N)] ++ G2_1) in ok.
           eapply fresh_mid_head; eauto.
          assert (b `notin` dom G2). simpl_env in H3. notin_solve.
         assert (dom G2 = dom (subst_typ_gamma a b G2)) as domeq. eapply subst_typ_gamma_dom; eauto. 
         rewrite domeq in a0_notin_G2.
         eapply binds_tail; eauto.
         SSSCase "b disjoint from e effect".
         assert (fx_e = fx0). clear IHT0.
           inversion split_fx.
           inversion s. 
           subst fx_newe.
           assert (a `notin` fx0).
             assert (a `notin` {}). notin_solve.
             rewrite <- H in H2.
             unfold not. intro.
             destruct H2. fsetdec.
         eapply union_identity; eauto.
         subst fx_e.
         eapply split_A. fsetdec.
         (* destruct a <> a *)
         destruct n. auto.
SCase "bindsa0_G2".
simpl.
       assert (b <> a0) as b_neq_a0.
         inversion k_b.
         destruct (binds_exists_singleton _ _ _ binds_a0_G2) as [G2_1 [G2_2 G2_eq]].
         assert (a0 `notin` (dom (G2_2 ++ [(a,binding_kind kind_N)]++ G1))).
           pose proof (wf_is_ok _ _ wf_G) as ok.
           assert (binds a0 (binding_kind kind_N) (G2 ++ ([(a, binding_kind kind_N)] ++ G1))).
             eapply binds_weaken; eauto.
           rewrite G2_eq in H3, ok.
           rewrite_env (G2_1 ++ [(a0, binding_kind kind_N)] ++ (G2_2 ++ [(a, binding_kind kind_N)] ++ G1)) in H3.
           rewrite_env (G2_1 ++ [(a0, binding_kind kind_N)] ++ (G2_2 ++ [(a, binding_kind kind_N)] ++ G1)) in ok.
           eapply fresh_mid_tail; eauto.
           pose proof (binds_In _ _ _ _ H1) as b_in_G1.
           assert (a0 `notin` dom G1). simpl_env in H3. notin_solve.
           unfold not. intros.
           rewrite H5 in b_in_G1. contradiction.
destruct (a==a0) as [a_eq_a0 | a_neq_a0].
(* a_eq_a0 *)
   subst a0.
   destruct (binds_exists_singleton _ _ _ binds_a0_G2) as [G2_1 [G2_2 G2_eq]].
          assert (a `notin` (dom (G2_2 ++ [(a, binding_kind kind_N)] ++ G1))).
           pose proof (wf_is_ok _ _ wf_G) as ok.
           assert (binds a (binding_kind kind_N) (G2 ++ [(a, binding_kind kind_N)] ++ G1)).
             eapply binds_weaken; eauto.
           rewrite G2_eq in H, ok.
           rewrite_env (G2_1 ++ [(a, binding_kind kind_N)] ++ (G2_2 ++ [(a, binding_kind kind_N)] ++ G1)) in H.
           rewrite_env (G2_1 ++ [(a, binding_kind kind_N)] ++ (G2_2 ++ [(a, binding_kind kind_N)] ++ G1)) in ok.
           eapply fresh_mid_tail; eauto.
           simpl_env in H.
           notin_solve.
(* a_neq_a0 *)
     cut (exists fx_e', splitA (singleton a) fx_e' fx_e). intro cut_ex.
     destruct cut_ex as [fx_e' split'].
     cut (b `notin` fx_e'). intro b_notin_fxe'.
     eapply type_NEW.
       eapply (IHT G2 G1 wf_G1 k_b fx_e'); eauto using refl_equal.
       eapply IHT0; eauto using refl_equal.
       eapply wf_env_containment; (eauto || fsetdec).
       SSCase "a0 available".
         assert (binds a0 (binding_kind kind_N) (subst_typ_gamma a b G2)).
           eapply Gamma_subst_typ_binding_kind; eauto.
         eapply binds_head; eauto.
       SSCase "a0 disjoint from e effect". clear IHT IHT0.
       assert (splitA (singleton a0) fx_e' fx0) as splitter. eauto using split_trans_9.
       inversion splitter.
       assert ((AtomSet.F.inter (singleton a0) (singleton b `union` fx_e')) = {}) as inter.
          assert ((AtomSet.F.inter (singleton a0) fx_e') = {}) as inter0.
            inversion s.
            inversion split'. 
            rewrite <- H10 in H3.
            rewrite (demorgan_1 (singleton a0) (singleton a) fx_e') in H3.
            rewrite <- H.
            assert (singleton a0 `inter` singleton a = {}).
              fsetdec.
            reflexivity.
          rewrite (demorgan_1 (singleton a0) (singleton b) fx_e').
          assert (singleton a0 `inter` singleton b = {}).
              fsetdec.
          rewrite H3; rewrite inter0; fsetdec.
        assert ((singleton b `union` singleton a0 `union` fx_e') = 
                (singleton a0 `union` singleton b `union` fx_e')) as ut; [fsetdec | rewrite ut].
        eapply split_A; eauto.
        (* cut b_notin_fxe' *)
        clear IHT IHT0.
        inversion s.
        inversion split'.
        inversion split_fx.
        subst.
        assert (b `notin` (singleton a `union` fx0)) as notin_u.
        notin_solve.
        rewrite H10 in notin_u. fsetdec.
        (* cut : split' *)
        eapply split_trans_10; eauto.
(* cut b <> a *)
        clear IHT b0 IHT0.
        assert (binds a (binding_kind kind_N) (G2 ++ [(a, binding_kind kind_N)] ++ G1)) as ba.
          eapply binds_mid; eauto using wf_is_ok.
         inversion k_b.
         assert (a `notin` (dom G1)).
           eapply fresh_mid_tail; eauto using wf_is_ok.
           pose proof (binds_In _ _ _ _ H1) as b_in_G1.
           unfold not. intros.
           subst b. subst a1. contradiction.
Case "type_ABS".
intros. injection Heqt_fxe; intros; subst. simpl.
cutrewrite (ptype (typ_fun t_x t_e) A fx_e = ptype (typ_fun t_x t_e) A (singleton b `union` fx0)).
assert ((subst_typ_typ a b (ptype (typ_fun t_x t_e) A (singleton b `union` fx0))) = (ptype (subst_typ_typ a b (typ_fun t_x t_e)) A (singleton b `union` fx0))) as subst_ptype_eq.
  eapply subst_typ_ptype; auto.
rewrite subst_ptype_eq. simpl. 
pick fresh y and apply type_ABS.
rewrite_env ((subst_typ_gamma a b ([(y, binding_typ t_x)] ++ G2)) ++ G1).
assert (y `notin` L) as y_notin_L. notin_solve.
assert (wf_env ([(y,binding_typ t_x)]++G2++[(a, binding_kind kind_N)]++G1) (aqual y k A)) as wf_ext_env.
    clear IHT H t subst_ptype_eq.
    pose proof (kinding_wf_typ _ _ _ k0) as wf_t_x.
    destruct (aqual_cases A y k) as [ aq_eq_A | aq_eq_yA ].
      rewrite aq_eq_A.
      apply wf_env_typ. assumption. simpl_env. notin_solve. assumption.
      rewrite aq_eq_yA.
      apply wf_env_typ_A. assumption. simpl_env. notin_solve. assumption.


assert (lc_typ b) as lc_b. constructor.
rewrite <- (subst_typ_exp_open_exp_commute a b y e lc_b).
rewrite (open_typ_subst_typ_typ_commute a b y t_e lc_b).
(* first premise ... typing function body using IH *)
eapply (H y y_notin_L ([(y, binding_typ t_x)]++G2)); eauto using refl_equal.
eapply IHT; eauto.
eapply wf_env_containment; (eauto || fsetdec).
(* cut : ptype equality *)
eapply ptype_union_equality.
inversion split_fx.
  assert (AtomSet.F.is_empty (A `union` singleton a `union` fx0) = false) as F1.
    apply (non_empty_3 (A `union` singleton a `union` fx0) a). fsetdec.
  assert (AtomSet.F.is_empty (A `union` singleton b `union` fx0) = false) as F2.
    apply (non_empty_3 (A `union` singleton b `union` fx0) b). fsetdec.
  rewrite F1. rewrite F2. reflexivity.
Case "type_TAB_NOFX".
intros. injection Heqt_fxe; intros; subst. simpl.
rewrite (subst_typ_ptype a b (typ_univ k NO_FX t_e) A fx_e). simpl.
assert ((ptype (typ_univ k NO_FX (subst_typ_typ a b t_e)) A fx_e) =
        (ptype (typ_univ k NO_FX (subst_typ_typ a b t_e)) A (singleton b `union` fx0))) as ptype_un_eq.
  eapply ptype_union_equality.
  inversion split_fx.
    assert (AtomSet.F.is_empty (A `union` singleton a `union` fx0) = false) as F1.
      apply (non_empty_3 (A `union` singleton a `union` fx0) a). fsetdec.
    assert (AtomSet.F.is_empty (A `union` singleton b `union` fx0) = false) as F2.
      apply (non_empty_3 (A `union` singleton b `union` fx0) b). fsetdec.
    rewrite F1. rewrite F2. reflexivity.
rewrite ptype_un_eq.
pick fresh c and apply type_TAB.
  SCase "typing tab body".
intros.
rewrite_env ((subst_typ_gamma a b ([(c, binding_kind k)] ++ G2)) ++ G1).
assert (c `notin` L) as c_notin_L. notin_solve.
assert (wf_env ([(c,binding_kind k)]++G2++[(a, binding_kind kind_N)]++G1) A) as wf_ext_env.
    apply wf_env_kind. assumption. simpl_env. notin_solve.
assert (c `notin` fx_e) as c_notin_fxe. notin_solve.
assert (lc_typ b) as lc_b. constructor.
assert (a <> c) as a_n_c.
  intro; subst a. notin_solve.
rewrite (open_exp_typ_subst_typ_exp_commute a b e c lc_b a_n_c).
rewrite (open_typ_typ_subst_typ_typ_commute a b t_e c lc_b a_n_c).
eapply H; eauto using refl_equal.
SCase "simple kind".
assumption.

Case "typing_TAB_FX".
intros. injection Heqt_fxe; intros; subst. simpl.
rewrite (subst_typ_ptype a b (typ_univ k FX t_e) A fx_e). simpl.
assert ((ptype (typ_univ k FX (subst_typ_typ a b t_e)) A fx_e) =
        (ptype (typ_univ k FX (subst_typ_typ a b t_e)) A (singleton b `union` fx0))) as ptype_un_eq.
  eapply ptype_union_equality.
  inversion split_fx.
    assert (AtomSet.F.is_empty (A `union` singleton a `union` fx0) = false) as F1.
      apply (non_empty_3 (A `union` singleton a `union` fx0) a). fsetdec.
    assert (AtomSet.F.is_empty (A `union` singleton b `union` fx0) = false) as F2.
      apply (non_empty_3 (A `union` singleton b `union` fx0) b). fsetdec.
    rewrite F1. rewrite F2. reflexivity.
rewrite ptype_un_eq. clear ptype_un_eq.
pick fresh c and apply type_TAB_FX.
  SCase "subset".
    fsetdec.
  SCase "typing tab body".
rewrite_env ((subst_typ_gamma a b ([(c, binding_kind k)] ++ G2)) ++ G1).
assert (c `notin` L) as c_notin_L. notin_solve.
assert (wf_env ([(c,binding_kind k)]++G2++[(a, binding_kind kind_N)]++G1) A) as wf_ext_env.
    apply wf_env_kind. assumption. simpl_env. notin_solve.
assert (c `notin` fx_e) as c_notin_fxe. notin_solve.
assert (lc_typ b) as lc_b. constructor.
assert (a <> c) as a_n_c.
  intro; subst a. notin_solve.
rewrite (open_exp_typ_subst_typ_exp_commute a b e c lc_b a_n_c).
rewrite (open_typ_typ_subst_typ_typ_commute a b t_e c lc_b a_n_c).
pose proof (t c c_notin_L) as T. clear t.
inversion split_fx. subst fx_e.
rewrite_env (([(c, binding_kind k)] ++ G2) ++ [(a, binding_kind kind_N)] ++ G1) in T.
cut (b `notin` (fx0 `union` singleton c)). intro cut_bnotin.
cut (splitA (singleton a) (fx0 `union` singleton c) ((singleton a `union` fx0) `union` singleton c)). intro cut_split.
assert (wf_env  ([(c, binding_kind k)] ++ G2 ++ [(a, binding_kind kind_N)] ++ G1) A) as wf_ext.
  eapply wf_env_kind; (eauto || notin_solve).
rewrite (union_associative (singleton b) fx0 (singleton c)).
eapply (H c c_notin_L ([(c, binding_kind k)] ++ G2)); eauto using refl_equal.
(* cut_split *)
clear H T Te Heqt_fxe. subst.
rewrite (union_associative (singleton a) fx0 (singleton c)).
eapply split_A.
rewrite (demorgan_1 (singleton a) fx0 (singleton c)).
inversion split_fx. rewrite H.
assert (a `notin` singleton c). notin_solve.
clear - H3.
fsetdec.
(* cut_bnotin *)
notin_solve.
  SCase "simple kind".
  assumption.
Case "type_APP".
intros. injection Heqt_fxe; intros; subst. simpl.
assert (a `in` fx1 \/ a `in` fx2) as a_somewhere.
   clear - s0 split_fx.
         inversion split_fx. rewrite <- H2 in s0. inversion s0.
         assert (a `in` (fx1 `union` fx2)). rewrite H3. fsetdec.
         fsetdec.
assert (lc_typ b) as lc_b. constructor.
assert (b <> a) as b_neq_a.
  clear - k_b wf_G.
  inversion k_b.
         destruct (binds_exists_singleton _ _ _ H1) as [G1_1 [G1_2 G1_eq]].
         assert (a `notin` (dom G1)) as a_notin_G1.
           eapply fresh_mid_tail; eauto using wf_is_ok.
         unfold not; intro.
         subst a. rewrite G1_eq in a_notin_G1. simpl_env in a_notin_G1.
         notin_solve.
assert (b `notin` fx1 /\ b `notin` fx2) as b_notin_fx1_fx2.
   clear - s0 split_fx b_notin_fx b_neq_a.
   inversion split_fx.
   inversion s0.
   rewrite <- H2 in H6.
   assert (b `notin` (fx1 `union` fx2)) as b_notin_un.
     rewrite H6. notin_solve.
   split; notin_solve.
assert (AtomSet.F.Subset A1 A /\ AtomSet.F.Subset A2 A) as A12_sub_A.
   inversion s.
   split; fsetdec.
destruct A12_sub_A as [A1_sub_A A2_sub_A].
destruct b_notin_fx1_fx2 as [b_notin_fx1 b_notin_fx2].
destruct (splitA_splits fx1 fx2 fx_e s0 a) as [a_in_fx1_not_fx2 a_in_fx2_not_fx1].
destruct a_somewhere as [a_in_fx1 | a_in_fx2].
SCase "a_in_fx1".
  clear IHT2.
  pose proof (a_in_fx1_not_fx2 a_in_fx1) as a_notin_fx2.
  cut (exists fx1', splitA (singleton a) fx1' fx1). intro ex_fx1'. destruct ex_fx1' as [fx1' split_a_fx1'].
  assert (b `notin` fx1') as b_notin_fx1'.
    inversion split_a_fx1'. rewrite <- H2 in b_notin_fx1. notin_solve.
  simpl.
  rewrite (subst_typ_typ_open_typ_commute_weak a b e2 t lc_b).
  eapply type_APP.
     SSCase "split A1 A2 A".
       apply s.
     SSCase "t_e disjunct".
       destruct o as [t_e1_L | t_e1_R].
       assert ((subst_typ_typ a b t_e1) = typ_fun (subst_typ_typ a b t2) (subst_typ_typ a b t)). 
          subst t_e1; simpl; auto. left; apply H.
       assert ((subst_typ_typ a b t_e1) = typ_qtype (typ_fun (subst_typ_typ a b t2) (subst_typ_typ a b t))). 
          subst t_e1; simpl; auto. right; apply H.
     SSCase "typing e1".
       eapply (IHT1 G2 G1 wf_G1 k_b fx1' b_notin_fx1' fx1); eauto using refl_equal, wf_env_containment.
     SSCase "typing e2".
       eapply type_substitution_preserves_typing; eauto using refl_equal, wf_env_containment.
     SSCase "effect splitting".
      clear - s0 split_fx split_a_fx1' a_in_fx1 a_notin_fx2 b_notin_fx1 b_notin_fx2.
      eapply effect_splitting; eauto. 
     SSCase "cut ex_fx1'".
      clear - a_in_fx1.
      exists (AtomSet.F.remove a fx1).
      assert ((singleton a `union` (AtomSet.F.remove a fx1)) = fx1).
               fsetdec.
      pattern fx1 at -1.
      rewrite <- H.
      constructor.
      fsetdec.

SCase "a_in_fx2".
  clear IHT1.
  pose proof (a_in_fx2_not_fx1 a_in_fx2) as a_notin_fx1.
  cut (exists fx2', splitA (singleton a) fx2' fx2). intro ex_fx2'. destruct ex_fx2' as [fx2' split_a_fx2'].
  assert (b `notin` fx2') as b_notin_fx2'.
    inversion split_a_fx2'. rewrite <- H2 in b_notin_fx2. notin_solve.
  simpl.
  rewrite (subst_typ_typ_open_typ_commute_weak a b e2 t lc_b).
  eapply type_APP.
     SSCase "split A1 A2 A".
       apply s.
     SSCase "t_e disjunct".
       destruct o as [t_e1_L | t_e1_R].
       assert ((subst_typ_typ a b t_e1) = typ_fun (subst_typ_typ a b t2) (subst_typ_typ a b t)). 
          subst t_e1; simpl; auto. left; apply H.
       assert ((subst_typ_typ a b t_e1) = typ_qtype (typ_fun (subst_typ_typ a b t2) (subst_typ_typ a b t))). 
          subst t_e1; simpl; auto. right; apply H.
     SSCase "typing e1".
       eapply type_substitution_preserves_typing; eauto using refl_equal, wf_env_containment.

     SSCase "typing e2".
       eapply (IHT2 G2 G1 wf_G1 k_b fx2' b_notin_fx2' fx2); eauto using refl_equal, wf_env_containment.

     SSCase "effect splitting".
      clear - subsubcase s0 split_fx split_a_fx2' a_in_fx2 a_notin_fx1 b_notin_fx1 b_notin_fx2.
      assert (splitA (singleton b `union` fx2') fx1 (singleton b `union` fx0)).
        eapply effect_splitting; eauto using split_commutes.
      eapply split_commutes; eauto.

     SSCase "cut ex_fx2'".
      clear - a_in_fx2.
      exists (AtomSet.F.remove a fx2).
      assert ((singleton a `union` (AtomSet.F.remove a fx2)) = fx2).
               fsetdec.
      pattern fx2 at -1.
      rewrite <- H.
      constructor.
      fsetdec.

Case "typing_TAP_NOFX".

intros. injection Heqt_fxe; intros; subst. simpl.
simpl.
rewrite (subst_typ_typ_open_typ_typ_commute_weak a b t t'); try constructor.

eapply type_TAP_NOFX.

    SCase "t_e disjunct".
       destruct o as [t_e1_L | t_e1_R].
       assert ((subst_typ_typ a b te) = typ_univ k NO_FX (subst_typ_typ a b t')).
          subst te; simpl; auto. left; apply H.
       assert ((subst_typ_typ a b te) = typ_qtype (typ_univ k NO_FX (subst_typ_typ a b t'))).
          subst te; simpl; auto. right; apply H.

    SCase "typing tabs body".
       eapply IHT; eauto using refl_equal.

    SCase "kinding".
       assert (AtomSet.F.Subset {} A). fsetdec.
       eapply IHT0; eauto using refl_equal, wf_env_containment.

Case "typing_TAP_FX".

intros. injection Heqt_fxe; intros; subst. 
rewrite (subst_typ_typ_open_typ_typ_commute_weak a b a0 t'); try constructor.
simpl.

destruct (a == a0) as [a_eq_a0 | a_neq_a0].

  SCase "a_eq_a0".
   subst a0.

   eapply type_TAP_FX.

   SSCase "t_e disjunct".
       destruct o as [t_e1_L | t_e1_R].
       assert ((subst_typ_typ a b te) = typ_univ kind_N FX (subst_typ_typ a b t')).
          subst te; simpl; auto. left; apply H.
       assert ((subst_typ_typ a b te) = typ_qtype (typ_univ kind_N FX (subst_typ_typ a b t'))).
          subst te; simpl; auto. right; apply H.

    SSCase "typing e body".
       assert (a `notin` fx).
         clear - s.
         inversion s. eauto using inter_notin.
    
       eapply type_substitution_preserves_typing; eauto using refl_equal.

    SSCase "kinding".
       assert (AtomSet.F.Subset {} A) as empty_subset. fsetdec.
       pose proof (wf_env_containment _ _ _ wf_G empty_subset) as wf_G_empty.
       pose proof (IHT0 _ _ _ (refl_equal (G2 ++ [(a, binding_kind kind_N)] ++ G1)) wf_G_empty wf_G1 k_b) as fromIH.
       simpl in fromIH.
         destruct (a==a). 
           assumption.
           destruct n. auto.

     SSCase "effect splitting".
       clear - s split_fx b_notin_fx.
       assert (fx = fx0).
         inversion split_fx.
         inversion s.
         rewrite <- H6 in H2.
         eapply union_identity; eauto using inter_notin.
       subst fx0.
       constructor. fsetdec.

  SCase "a_neq_a0".

       cut (exists fx', splitA (singleton a) fx' fx). intro cut_fx'. destruct cut_fx' as [fx' s_fx'].
       cut (b <> a). intro b_n_a.
       assert (b `notin` fx').
         clear -s_fx' b_notin_fx split_fx s b_n_a.
         assert (b `notin` fx_e).
           clear - split_fx b_notin_fx b_n_a.
           inversion split_fx.
           notin_solve.
         assert (b `notin` fx).
           inversion s.
             rewrite <- H3 in H. clear -H.
           notin_solve.
         inversion s_fx'.
            rewrite <- H4 in H0. clear -H0.
            notin_solve.

    eapply type_TAP_FX.

    SSCase "t_e disjunct".
       destruct o as [t_e1_L | t_e1_R].
       assert ((subst_typ_typ a b te) = typ_univ kind_N FX (subst_typ_typ a b t')).
          subst te; simpl; auto. left; apply H0.
       assert ((subst_typ_typ a b te) = typ_qtype (typ_univ kind_N FX (subst_typ_typ a b t'))).
          subst te; simpl; auto. right; apply H0.

    SSCase "typing tabs body".

       eapply (IHT G2 _ wf_G1 k_b _ H _ s_fx'); eauto using refl_equal.

    SSCase "kinding".
       assert (AtomSet.F.Subset {} A) as empty_subset. fsetdec.
       pose proof (wf_env_containment _ _ _ wf_G empty_subset) as wf_G_empty.
       pose proof (IHT0 _ _ _ (refl_equal (G2 ++ [(a, binding_kind kind_N)] ++ G1)) wf_G_empty wf_G1 k_b) as fromIH.
       simpl in fromIH.
         destruct (a==a0). 
           contradiction.
           assumption.

     SSCase "effect splitting".
       clear - s split_fx b_notin_fx s_fx' a_neq_a0.
       assert (splitA (singleton a0) fx' fx0).
         assert (fx0 = singleton a0 `union` fx') as id.
           assert (a `notin` fx0) as a_n_fx0.
             inversion split_fx.
             eauto using inter_notin.
           assert (a `notin` fx') as a_n_fx'.
             inversion s_fx'. eauto using inter_notin.
           assert (a `notin` (singleton a0 `union` fx')) as a_n_u. fsetdec.
           inversion split_fx as [a1 a2 split_fx_inter a3 a4 split_fx_union].
           inversion s as [a5 a6 s_inter a7 a8 s_union].
           inversion s_fx' as [a5' a6' s_inter' a7' a8' s_union'].
           rewrite <- s_union' in s_union.
           rewrite <- s_union in split_fx_union.
           clear - a_n_fx0 a_n_u split_fx_union.
           rewrite <- (union_associative (singleton a0) (singleton a) fx') in split_fx_union.
           rewrite (union_commutes (singleton a0) (singleton a)) in split_fx_union.
           rewrite (union_associative (singleton a) (singleton a0)  fx') in split_fx_union.
           eapply union_identity; eauto.
         rewrite id.
         constructor.
           clear - s s_fx'.
           assert (a0 `notin` fx) as i1.
             inversion s. eauto using inter_notin.
           clear - i1 s_fx'.
             inversion s_fx'. 
             assert (a0 `notin` fx'). 
               unfold not; intro. fsetdec.
           fsetdec.
         eapply split_commutes.
           pose proof (split_commutes _ _ _ H).
           eauto using split_trans_8.
 (* cut b <> a *)
        assert (binds a (binding_kind kind_N) (G2 ++ [(a, binding_kind kind_N)] ++ G1)) as ba.
          eapply binds_mid; eauto using wf_is_ok.
         inversion k_b.
         assert (a `notin` (dom G1)).
           eapply fresh_mid_tail; eauto using wf_is_ok.
           pose proof (binds_In _ _ _ _ H1) as b_in_G1.
           unfold not. intros.
           subst b. subst a1. contradiction.
(* cut : exists fx' *)
assert (a `in` fx) as a_in_fx.
  clear - split_fx s a_neq_a0.
  inversion split_fx.
  inversion s.
  rewrite <- H6 in H2.
  clear -H2 a_neq_a0.
  assert (a `in` (singleton a `union` fx0)). fsetdec.
  rewrite H2 in H.
  destruct (AtomSet.F.union_1 H) as [a_in_a0 | a_in_fx].
    destruct a_neq_a0. fsetdec. 
    assumption.
 clear - a_in_fx.
      exists (AtomSet.F.remove a fx).
      assert ((singleton a `union` (AtomSet.F.remove a fx)) = fx).
               fsetdec.
      pattern fx at -1.
      rewrite <- H.
      constructor.
      fsetdec.             
Case "typing_BOT".
intros. eapply type_BOT; eauto.

Case "typing_DROP".
intros. injection Heqt_fxe;intros;subst. simpl.
eapply type_DROP.
pose proof (IHT G2 G1 wf_G1 k_b _ b_notin_fx _ split_fx 
                _ (refl_equal (typ_sing t a0, fx_e)) wf_G
                (refl_equal (G2 ++ [(a, binding_kind kind_N)] ++ G1)) T).
simpl in H. apply H.

Case "type_AFN".
intros. injection Heqt_fxe;intros;subst;simpl.

assert (a `in` fx1 \/ a `in` fx2) as a_somewhere.
   clear - s0 split_fx.
         inversion split_fx. rewrite <- H2 in s0. inversion s0.
         assert (a `in` (fx1 `union` fx2)). rewrite H3. fsetdec.
         fsetdec.
assert (lc_typ b) as lc_b. constructor.
assert (b <> a) as b_neq_a.
  clear - k_b wf_G.
  inversion k_b.
         destruct (binds_exists_singleton _ _ _ H1) as [G1_1 [G1_2 G1_eq]].
         assert (a `notin` (dom G1)) as a_notin_G1.
           eapply fresh_mid_tail; eauto using wf_is_ok.
         unfold not; intro.
         subst a. rewrite G1_eq in a_notin_G1. simpl_env in a_notin_G1.
         notin_solve.
assert (b `notin` fx1 /\ b `notin` fx2) as b_notin_fx1_fx2.
   clear - s0 split_fx b_notin_fx b_neq_a.
   inversion split_fx.
   inversion s0.
   rewrite <- H2 in H6.
   assert (b `notin` (fx1 `union` fx2)) as b_notin_un.
     rewrite H6. notin_solve.
   split; notin_solve.
assert (AtomSet.F.Subset A1 A /\ AtomSet.F.Subset A2 A) as A12_sub_A.
   inversion s.
   split; fsetdec.
destruct (splitA_splits fx1 fx2 fx_e s0 a) as [a_in_fx1_not_fx2 a_in_fx2_not_fx1].
destruct a_somewhere as [a_in_fx1 | a_in_fx2].
SCase "a_in_fx1".
pose proof (a_in_fx1_not_fx2 a_in_fx1) as a_notin_fx2.
assert (exists fx1', splitA (singleton a) fx1' fx1) as ex_fx1'.
      clear - a_in_fx1.
      exists (AtomSet.F.remove a fx1).
      assert ((singleton a `union` (AtomSet.F.remove a fx1)) = fx1).
               fsetdec.
      pattern fx1 at -1.
      rewrite <- H.
      constructor.
      fsetdec.
destruct ex_fx1' as [fx1' s_fx1'].
assert (b `notin` fx1'). 
  inversion s_fx1'.  destruct b_notin_fx1_fx2. clear -H2 H3. fsetdec.
cut (effect_ok (singleton b `union` fx0) ((subst_typ_gamma a b G2) ++ G1)). intro.
cut (splitA ((singleton b) `union` fx1') fx2 (singleton b `union` fx0)). intro.
eapply type_AFN; intuition eauto using wf_env_containment.
  SSCase "cut effect spliting".
   clear - b_notin_fx1_fx2 s_fx1' H split_fx s0 a_in_fx1 a_notin_fx2.
   eapply effect_splitting; intuition eauto. 
  SSCase "cut effect ok".
   clear - wf_G1 k_b b_notin_fx split_fx wf_G e0 b_neq_a.

   
     eapply effect_ok_subst_typ_gamma; eauto.
SCase "a_in_fx2".
pose proof (a_in_fx2_not_fx1 a_in_fx2) as a_notin_fx1.
assert (exists fx2', splitA (singleton a) fx2' fx2) as ex_fx2'.
      clear - a_in_fx2.
      exists (AtomSet.F.remove a fx2).
      assert ((singleton a `union` (AtomSet.F.remove a fx2)) = fx2).
               fsetdec.
      pattern fx2 at -1.
      rewrite <- H.
      constructor.
      fsetdec.
destruct ex_fx2' as [fx2' s_fx2'].
cut (effect_ok (singleton b `union` fx0) ((subst_typ_gamma a b G2) ++ G1)). intro.
cut (splitA fx1 ((singleton b) `union` fx2') (singleton b `union` fx0)). intro.

eapply type_AFN; intuition eauto using type_substitution_preserves_typing, wf_env_containment.
   SSCase "cut effect splitting".
     clear - b_notin_fx1_fx2 s_fx2' H split_fx s0 a_in_fx2 a_notin_fx1.
     eapply split_commutes.
     eapply effect_splitting; intuition eauto using split_commutes.
   SSCase "cut effect ok".
    clear - wf_G1 k_b b_notin_fx split_fx wf_G e0 b_neq_a.
    eapply effect_ok_subst_typ_gamma; eauto.

Case "type_B".
intros; injection Heqt_fxe; intros; subst.
  inversion split_fx. 
    clear -H.
    assert (a `in` {}).
    rewrite <- H. fsetdec. fsetdec.
   
Case "type_B1".
intros. injection Heqt_fxe;intros; subst t0; subst fx.
rename G1 into G_1.
rename G2 into G_2.
rename G0 into G2.
rename G3 into G1.
cut ((exists G_pivot, G1 = G_pivot ++ G_1) \/
     (exists G_pivot, G_2 ++ G_1=  G_2 ++ G_pivot ++ [(a, binding_kind kind_N)] ++ G1)). intro cut_pivot.
destruct cut_pivot as [[G_pivot G1_eq] | [G_pivot G_2_1_eq]].
SCase "G_1 prefix of G1".
  subst G1.
  cut (subst_typ_gamma a b G_pivot = G_pivot). intro subst_pivot.
  rewrite <- subst_pivot.
  cut (subst_typ_gamma a b G2 ++ subst_typ_gamma a b G_pivot ++ G_1 =
       subst_typ_gamma a b (G2 ++ G_pivot) ++ G_1). intro subst_concat_eq.
  rewrite subst_concat_eq.
  simpl.
  eapply type_B1.
    assumption.
    assert (a `notin` dom G_1) as a_notin_G_1.
      rewrite HeqG in wf_G.
      pose proof (wf_is_ok _ _ wf_G) as G_ok.
      pose proof (fresh_mid_tail _ _ _ _ _ G_ok). simpl_env in H. notin_solve.
    rewrite (subst_typ_wf_exp _ _ a b w a_notin_G_1).
    assumption.
    rewrite <- subst_concat_eq. rewrite subst_pivot.
    pose proof (IHT G2 (G_pivot ++ G_1) wf_G1 k_b _ b_notin_fx _ split_fx _ (refl_equal (t, fx_e)) wf_G HeqG T) as fromIH.
    simpl in fromIH. apply fromIH.
  SSCase "cut subst_concat_eq".
    unfold subst_typ_gamma.
    simpl_env. congruence.
  SSCase "cut subst_pivot".
    assert (a `notin` dom (G_pivot ++ G_1)) as a_notin_G_pivot.
      rewrite HeqG in wf_G.
      pose proof (wf_is_ok _ _ wf_G) as G_ok.
      eapply fresh_mid_tail; (eauto || notin_solve).
    clear - a_notin_G_pivot wf_G HeqG.
    assert (wf_env (G_pivot ++ G_1) {}).
      rewrite HeqG in wf_G.
      eapply wf_env_tail; eauto using wf_env_tail.
    assert (subst_typ_gamma a b (G_pivot ++ G_1) = G_pivot ++ G_1) as map_cat.
      eapply subst_typ_gamma_invariant; eauto.
    unfold subst_typ_gamma.
    unfold subst_typ_gamma in map_cat.     simpl_env in map_cat.
    destruct (map_concat_injection _ _ _ _ map_cat). eauto.
 SCase "G_2_1_eq".
   assert (G_1 = G_pivot ++ [(a, binding_kind kind_N)] ++ G1) as G_1_eq.
      eapply list_concat_injection_suffix. eauto.

Admitted.

(* clear IHT. simpl in fromIH. *)
(* eapply type_B1. *)
(*  SCase "only_names G3". *)
(*     clear - HeqG wf_G1 o. *)


(*  WF_G1xG2Ax G2 G1 wf_G1 Kind_txk  _ _ _ T_v split_fx _  *)
(*                 (refl_equal (t, fx_e)) A0 x_notin_A WF_G1xG2Ax HeqAx HeqG T) as fromIH. *)
(* simpl in fromIH. *)
(* rewrite tid in fromIH. *)
(*    assert (subst_exp x v v0 = v0) as v0id. *)
(*      assert (x `notin` dom G1_1) as xnotin_G1_1. *)
(*        eapply binds_no_vars_sub; eauto. *)
(*    eapply subst_wf_exp_identity; eauto. *)
(* rewrite v0id in fromIH. *)
(* destruct (only_names_prefix _ _ _ _ _ _  HeqG o) as [G1_1' G1_eq]. *)
(* subst G1. *)
(* rewrite_env ((subst_gamma x v G2 ++ G1_1') ++ G1_1). *)
(* eapply type_B1; (eauto || (simpl_env; eauto)). *)

(* intros; injection Heqt_fxe; intros; subst. *)
(* simpl. *)
(* eapply type_B1; eauto. *)



End LAIR_TypeSubst.
